
#include "keypad.h"
#include <stdlib.h>
//---------------------------------------------------




KP_INST keypad_inst;


//---------------------------------------------------
void keypad_init (uint8_t columns, uint8_t rows)
{
	keypad_inst.ncols = columns;
	keypad_inst.nrows = rows;
  for (int c=0;keypad_inst.ncols > c; keypad_inst.mask+=1<<c ,c++);		//maska na odfiltrovani nepouzitych pinu GPIO
	for (keypad_inst.rowshift = 1;keypad_inst.ncols > ( 1 << keypad_inst.rowshift); keypad_inst.rowshift++);	//rowshift
	for (keypad_inst.keydown = 0xC0, keypad_inst.keyup = 0x80; (keypad_inst.nrows << keypad_inst.rowshift) > keypad_inst.keydown; keypad_inst.keydown <<= 1, keypad_inst.keyup <<= 1);
	//keypad_inst.now = malloc(keypad_inst.nrows * sizeof (uint32_t));
	//keypad_inst.then = malloc(keypad_inst.nrows * sizeof (uint32_t));
	keypad_inst.rollover=3;
	keypad_inst.numkeys=0;
	}

	uint16_t count;
//---------------------------------------------------
void keypad_read (void)
{
for (uint8_t i = 0; i < keypad_inst.nrows; i++)
	{
	
	keypad_inst.scan = GPIOD->IDR & keypad_inst.mask;
	
	
	if (keypad_inst.scan == keypad_inst.now[keypad_inst.row] && keypad_inst.scan != keypad_inst.then[keypad_inst.row])
		//debounce and changed
	{
		for (int c = 0; c < keypad_inst.ncols; c++){
			int mask = 1 << c;
				if ((keypad_inst.then[keypad_inst.row] & mask) && !(keypad_inst.scan & mask)){ //keyup
						keypad_inst.keycode = keypad_inst.keyup + (keypad_inst.row << keypad_inst.rowshift) + c;
						
						for (int buff = 0; buff < keypad_inst.rollover ; buff++) //najit jestli je v bufferu
							{
								if (keypad_inst.keybuffer[buff] == (keypad_inst.keycode|keypad_inst.keydown))
								{	
									keypad_inst.keysend[keypad_inst.keypos]=keypad_inst.keycode;
									keypad_inst.keypos++;
									for (int shift=buff;shift<=keypad_inst.rollover;shift++)		//kdyz najde odmaze z bufferu a posune buffer
										{
											keypad_inst.keybuffer[shift]=keypad_inst.keybuffer[shift+1];  //posunout buffer
										}
										buff--;
										keypad_inst.numkeys--;
										//HAL_Delay(1000);
								}
							}
											
				}
				else if (!(keypad_inst.then[keypad_inst.row] & mask) && (keypad_inst.scan & mask) && keypad_inst.numkeys<keypad_inst.rollover){ //keydown
						keypad_inst.keycode = keypad_inst.keydown + (keypad_inst.row << keypad_inst.rowshift) + c;
						keypad_inst.keybuffer[keypad_inst.numkeys]=keypad_inst.keycode;
					  keypad_inst.keysend[keypad_inst.keypos]=keypad_inst.keycode;
					keypad_inst.keypos++;
					keypad_inst.numkeys++;
					
					//HAL_Delay(1000);
				}
				if (keypad_inst.keypos >20) keypad_inst.keypos=20;
				
			}
		}
	keypad_inst.then[keypad_inst.row] = keypad_inst.now[keypad_inst.row];
	keypad_inst.now[keypad_inst.row] = keypad_inst.scan;
	HAL_GPIO_WritePin (GPIOE, 1<<keypad_inst.row,GPIO_PIN_RESET);
	keypad_inst.row++;
	if (keypad_inst.row >= keypad_inst.nrows) keypad_inst.row=0;
	HAL_GPIO_WritePin (GPIOE, 1<<keypad_inst.row,GPIO_PIN_SET);
	//HAL_Delay(100);
	}
		if ( count>200)
		{
		if (keypad_inst.keysend[1] !=0)
			{
			for (int c=0;c<=22;c++)
				{
				keypad_inst.keysend[c]=keypad_inst.keysend[c+1];  //posunout buffer
				}
				keypad_inst.keypos--;
				}
			count=0;
			}
		count++;
}
/******END OF FILE****/
