 #include "sserial.h"
 //#include "stm32f4xx_hal.h"
 #include "keypad.h"
//---------------------------------------------------

extern UART_HandleTypeDef huart1;
extern KP_INST keypad_inst;


//--------------------------------------------------- 

//---------------------------------------------------------
uint8_t byte; 				//byte read IT
uint8_t enc3Counter,enc4Counter,enc5Counter; 
uint8_t CardName[4]="7i99";
uint16_t SwRevision,HwRevision;
uint16_t NVWatchDogTimeout,NVBaudRate;
uint32_t NVUnitNumber,UnitNumber;
uint16_t *addr,value;
uint8_t gtoc_msb,gtoc_lsb;
uint8_t ptoc_msb,ptoc_lsb;
uint8_t bytes_in,bytes_out; 
uint8_t sw_mode_index,hw_mode_index=1;
uint8_t size,size2;

uint8_t PTOCtable [60] ;
uint8_t GTOCtable [60] ;
uint8_t *pTOCtable;
uint8_t pos_RX,command;
uint16_t readaddr;
uint8_t bytes2read = 0xee,bytes2send;
uint8_t RXBUFF [20];
uint8_t TXBUFF [20];
uint8_t TXcrc;
uint8_t LBPstatus;
uint8_t data_ready=0;
uint8_t watchdog;
uint8_t feed_overide,spin_overide;
uint8_t saw;			//***
//uint32_t count;

uint8_t CRC_table[256] =    			 {0, 94, 188, 226, 97, 63, 221, 131, 194, 156, 126, 32, 163, 253, 31, 65,
                                    157, 195, 33, 127, 252, 162, 64, 30, 95, 1, 227, 189, 62, 96, 130, 220,
                                    35, 125, 159, 193, 66, 28, 254, 160, 225, 191, 93, 3, 128, 222, 60, 98,
                                    190, 224, 2, 92, 223, 129, 99, 61, 124, 34, 192, 158, 29, 67, 161, 255,
                                    70, 24, 250, 164, 39, 121, 155, 197, 132, 218, 56, 102, 229, 187, 89, 7,
                                    219, 133, 103, 57, 186, 228, 6, 88, 25, 71, 165, 251, 120, 38, 196, 154,
                                    101, 59, 217, 135, 4, 90, 184, 230, 167, 249, 27, 69, 198, 152, 122, 36,
                                    248, 166, 68, 26, 153, 199, 37, 123, 58, 100, 134, 216, 91, 5, 231, 185,
                                    140, 210, 48, 110, 237, 179, 81, 15, 78, 16, 242, 172, 47, 113, 147, 205,
                                    17, 79, 173, 243, 112, 46, 204, 146, 211, 141, 111, 49, 178, 236, 14, 80,
                                    175, 241, 19, 77, 206, 144, 114, 44, 109, 51, 209, 143, 12, 82, 176, 238,
                                    50, 108, 142, 208, 83, 13, 239, 177, 240, 174, 76, 18, 145, 207, 45, 115,
                                    202, 148, 118, 40, 171, 245, 23, 73, 8, 86, 180, 234, 105, 55, 213, 139,
                                    87, 9, 235, 181, 54, 104, 138, 212, 149, 203, 41, 119, 244, 170, 72, 22,
                                    233, 183, 85, 11, 136, 214, 52, 106, 43, 117, 151, 201, 74, 20, 246, 168,
                                    116, 42, 200, 150, 21, 75, 169, 247, 182, 232, 10, 84, 215, 137, 107, 53};

																		
																		typedef struct {
   uint8_t record_type;
   uint8_t data_size;
   uint8_t data_type;
   uint8_t data_direction;
   uint32_t param_min;
   uint32_t param_max;
   uint16_t param_addr;
   uint8_t unit_and_name_string[25];
} PROCESS_DATA_DESCRIPTOR;

typedef struct {
    uint8_t record_type;
    uint8_t mode_index;
    uint8_t mode_type;
    uint8_t unused;
    char mode_name_string[8];
} MODE_DESCRIPTOR;

																


//---------------------------------------------------------

	PROCESS_DATA_DESCRIPTOR pdd_rec[12]  =              //number of items must be same as number of lines in definition 
			{	
			//record_type, data_size, data_type,direction,max,min,address,unit_string,name_strting
			0xa0,0x08, 0x02, 0x80, 0, 0x40228f5c, 0x0000, "pin\x00" "feed-overide\x00",    //0x40233333  2.55 IEE754       0x4023d70a 2.56
			0xa0,0x08, 0x02, 0x80, 0, 0x40228f5c, 0x0000, "pin\x00" "spin-overide\x00",		//0x40233333  2.55 IEE754
			0xa0,0x08, 0x01, 0x80, 0, 0, 0x0000, "bit\x00" "OUT\x00",
				
				
			0xa0,0x08, 0x06, 0x00, 0, 0x437f0000, 0x0000, "value\x00" "KEY\x00",
			0xa0,0x08, 0x08, 0x00, 0, 0, 0x0000, "count\x00" "feed-enc\x00",
			0xa0,0x08, 0x08, 0x00, 0, 0, 0x0000, "count\x00" "spin-enc\x00",	
				
				
			0xa0,0x10, 0x02, 0x80, 0, 0, 0x0000, "None\x00" "SwRevision\x00",
		  0xa0,0x10, 0x02, 0x80, 0, 0, 0x0000, "None\x00" "HwRevision\x00",
			0xa0,0x10, 0x04, 0x00, 0, 0, 0x0000, "None\x00" "NVWatchDogTimeout\x00",
			0xa0,0x20, 0x04, 0x00, 0, 0, 0x0000, "None\x00" "NVUnitNumber\x00",
			0xa0,0x10, 0x04, 0x40, 0, 0, 0x0000, "None\x00" "NVBaudRate\x00",
			0xa0,0x20, 0x04, 0x00, 0, 0, 0x0000, "None\x00" "UnitNumber\x00",
			};
			
			//data_type  02 - float
			//						06-u32




MODE_DESCRIPTOR md_rec [2] = 
// RECORD_type, MODE_index ,MODE_type, unused , mode name string
		{0xb0, 0x00, 0x00, 0x00, "hw0 ",
		 0xb0, 0x02, 0x01, 0x00, "sw0 "};


//---------------------------------------------------
void sserial_init (void)
{
	
	__HAL_UART_ENABLE_IT(&huart1, UART_IT_RXNE);    //enable interrupt RX not empty
  HAL_UART_Receive_IT(&huart1, &byte, 1);					//READ_BIT UART
	
	SwRevision=0x5555;
	pdd_rec[4].param_addr = (uintptr_t)&SwRevision;     //add address to param_addr for swrevision
	HwRevision=0x0123;
	pdd_rec[5].param_addr = (uintptr_t)&HwRevision;
	NVWatchDogTimeout=0x00ff;
	pdd_rec[6].param_addr = (uintptr_t)&NVWatchDogTimeout;
	NVUnitNumber=0x12121212;
	pdd_rec[7].param_addr = (uintptr_t)&NVUnitNumber;
	NVBaudRate=0x0003;
	pdd_rec[8].param_addr = (uintptr_t)&NVBaudRate;
	UnitNumber=0x25121314;
	pdd_rec[9].param_addr = (uintptr_t)&UnitNumber;
	
	
  size=sizeof(md_rec)/sizeof(MODE_DESCRIPTOR);
	size2=sizeof(pdd_rec)/sizeof(PROCESS_DATA_DESCRIPTOR);
	//GTOC   all mdrec and all ptoc (proces data + variables )
	
  //for (int i=0; i < sizeof(md_rec)/sizeof(MODE_DESCRIPTOR); i++) {
  for (int i=0; i < 12; i++) {

		GTOCtable[2*i+4]   = (uintptr_t)(&pdd_rec[i]);
		GTOCtable[2*i+5] = ((uintptr_t)&pdd_rec[i]>>8);
    }
	GTOCtable[0]=(uintptr_t)(&md_rec[0]);     //natvrdo hw a sw mode
	GTOCtable[1]=((uintptr_t)&md_rec[0]>>8);
	GTOCtable[2]=(uintptr_t)(&md_rec[1]);
	GTOCtable[3]=((uintptr_t)&md_rec[1]>>8);
		
	gtoc_lsb = (uintptr_t)(&GTOCtable[0]);
	gtoc_msb = (uintptr_t)(&GTOCtable[0])>>8 ;
		
	// PTOC  pdd without variables
		
		//for (int i=0; i < sizeof(pdd_rec)/sizeof(PROCESS_DATA_DESCRIPTOR); i++) {
		for (int i=0; i < 6; i++) {
			PTOCtable[2*i+4]   = (uintptr_t)(&pdd_rec[i]);//***if (c==4) c=0;
			PTOCtable[2*i+5] = ((uintptr_t)&pdd_rec[i]>>8);
		}
	PTOCtable[0]=(uintptr_t)(&md_rec[0]);     //natvrdo hw a sw mode
	PTOCtable[1]=((uintptr_t)&md_rec[0]>>8);
	PTOCtable[2]=(uintptr_t)(&md_rec[1]);
	PTOCtable[3]=((uintptr_t)&md_rec[1]>>8);
	bytes_in =  4;
	bytes_out = 7;
		
	ptoc_lsb = (uintptr_t)(&PTOCtable[0]);
	ptoc_msb = (uintptr_t)(&PTOCtable[0])>>8;
	hw_mode_index=1;

	
}
//---------------------------------------------------
void usart_handler (void)
{
  //enc3Counter = TIM3->CNT;
	enc3Counter = 25;
	enc4Counter = TIM4->CNT;
	//enc5Counter = TIM5->CNT;
	enc5Counter = 53;
if (bytes2read == (uint8_t)0xEE) 													// prvni byte - command
	{
//	HAL_UART_Receive_IT(&huart1, &byte, 1);
//																																									HAL_UART_Transmit(&huart1,p,1,5);
	pos_RX=0;
	command = byte;

	switch (command & LBPFUNCTIONMASK) {
		case	LBPRPC : 														//rpc command		10xx xxxx
				switch (command){

					case 0xBB:
					case 0xBC:
						bytes2read = 1;
						break;
					case 0xBD:
						bytes2read = bytes_out+1;
						break;
					default :	bytes2read = 0xEE;
						break;
				}
				break;
		case	LBPCOMMAND:														//LBP read/write 	01xx xxxx
				if ((command & LBPRWMASK) ==  LBPWRITE)								//LBP write		xx1x xxxx
				{
					if ((command & LBPADDMASK) == LBPA2)							//Two byte address included xxxx x1xx
					{
					bytes2read = 3;
					}
					else														//No address included, Last address used xxxx x0xx
					{
					bytes2read = 1;
					}
					bytes2read+=(uint8_t)(1 << (command & LBPDATASIZE));  //DataSize: Specifies data size, 00b = 1 bytes, 01b = 2 bytes, 10 b= 4 bytes, 11b = 8 bytes.
					//***zapis=(1 << (command & LBPDATASIZE));
				}
				else 															//LBP read data	xx0x xxxx
				{
					if ((command & LBPADDMASK) == LBPA2)							//Two byte address included xxxx x1xx
					{
					bytes2read = 3;
					}
					else														//No address included, Last address used xxxx x0xx
					{
					bytes2read = 1;
					}
				}
				break;
		case LBPLOCAL:															//LBP local function 0-31 11xx xxxx
				if ((command & LBPRWMASK) ==  LBPWRITE)								//LBP local write func		xx1x xxxx 0xE0 a dal
				{
					//
					switch (command){
						case 0xE1:
						case 0xE6:
						case 0xE7:
						case 0xEB:
						case 0xEC:
								bytes2read = 2;
							break;
						default :	bytes2read = 0xEE;
							break;
					}
					//
				}
				else 															//LBP 	local read func x0x xxxx		0xc0 - 0xdf
				{
					switch (command){
						case 0xC1:
						case 0xC7:
						case 0xD0:
						case 0xD1:
						case 0xD2:
						case 0xD3:
						case 0xD4:
						case 0xD5:
						case 0xD6:
						case 0xD7:
						case 0xDF: 	
							bytes2read = 1;
							break;
						default :	bytes2read = 0xEE;
							break;
					}
				}
				break ;
		default:	bytes2read = 0xEE	;					//nemelo by nastat  00

			break;										
		}
	}
else 																				// dalsi byte
	{
	//HAL_UART_Receive_IT(&huart1, &byte, 1);
	RXBUFF[pos_RX] = byte ;
	bytes2read--;
	if(bytes2read == 0) 														// posledni byte vyhodnotit retezec
		{
			bytes2read = 0xEE;
			if (data_ready) {

				HAL_GPIO_WritePin (GPIOC, GPIO_PIN_13, (GPIO_PinState) (RXBUFF[0] && 0x01 ));
				
				
				data_ready=0;
				
			}
				
					
			send_back();		
		}
	else 
		{
		pos_RX++;
		}
	}
  HAL_UART_Receive_IT(&huart1, &byte, 1);   //read next byte

  /* USER CODE END USART1_IRQn 1 */
}

//---------------------------------------------------

void send_back (void) 
	{
		watchdog=0;
		
		
	switch (command & LBPFUNCTIONMASK) {
		case	LBPRPC :{ 														//rpc command		10xx xxxx
			switch (command){
				case 0xBB:																									//GetDiscoveryInfo"
                         
						TXBUFF[0] = bytes_in;																			// number of bytes in
						TXBUFF[1] = bytes_out; 																		// number of bytes out
						TXBUFF[2] = ptoc_lsb; 															 // PTOC address             
						TXBUFF[3] = ptoc_msb ;                
						TXBUFF[4] = gtoc_lsb;																	// GTOC address
						TXBUFF[5] = gtoc_msb;
						bytes2send = 7;
				break;
			case 0xBC:																									//GetUnitNumber"
																																		// return 4 bytes + CRC
						TXBUFF[0] = 0x12;
						TXBUFF[1] = 0x12;
						TXBUFF[2] = 0x12;
						TXBUFF[3] = 0x12;
						bytes2send = 5;
						//WriteUART1(TX1_buf[0]);
				break;
			case 0xBD:														//ProcessDataRPC 
						feed_overide = RXBUFF[0];				
						spin_overide = RXBUFF[1]; 
						TXBUFF[0] = 0x00; 								//fault info
						//TXBUFF[1] = keyy[0];
						keypad_read();
						TXBUFF[1] = keypad_inst.keysend[0];
						/*if ( count>1000)
							{
								if (keypad_inst.keysend[1] !=0)
								{
								for (int c=0;c<=22;c++)
									{
										keypad_inst.keysend[c]=keypad_inst.keysend[c+1];  //posunout buffer
									}
								keypad_inst.keypos--;
								}
							count=0;
							if (keypad_inst.keypos>100) keypad_inst.keypos=0;
							}
							count++;*/
						
						TXBUFF[2] = enc5Counter;
						TXBUFF[3] = enc3Counter;
				    
						//count++;								//data***
						
						bytes2send = bytes_in +1 ;   //+1 crc
						data_ready=1;
				break;
				}
			}
		break;
		case	LBPCOMMAND:{														//LBP read/write 	01xx xxxx
				if ((command & LBPRWMASK) ==  LBPWRITE)								//LBP write		xx1x xxxx
				{
			//TODO write
					
					if ((command & LBPADDMASK) == LBPA2)							//Two byte address included xxxx x1xx
					{
					addr=((uint16_t*)((uint32_t)((RXBUFF[1]<<8)|RXBUFF[0])|SRAM_BASE));
					switch (command & LBPDATASIZE) {
						case LBPD1:										
									break;
						
						case LBPD2:
									value=((uint16_t)((RXBUFF[3]<<8)|RXBUFF[2]));
									*addr=value;
									break;
						}	
					
					TXBUFF[0]=0x00; 						//no crc
					bytes2send=1;
					}
					
				}
				else 															//LBP read data	xx0x xxxx
				{
					if ((command & LBPADDMASK) == LBPA2)							//Two byte address included xxxx x1xx
					{
						pTOCtable=((uint8_t*)((uint32_t)((RXBUFF[1]<<8)|RXBUFF[0])|SRAM_BASE));
						switch (command & LBPDATASIZE) {
							case LBPD1:
									if (pTOCtable == NULL) bytes2read=0xEE;
									else TXBUFF[0]=*pTOCtable;
												bytes2send=2;
													
									break;
							case LBPD2:
									TXBUFF[0]=*pTOCtable;
									TXBUFF[1]=*(pTOCtable+1);
									bytes2send=3;
									break;
							case LBPD4:
									TXBUFF[0]=*pTOCtable;
									TXBUFF[1]=*(pTOCtable+1);
									TXBUFF[2]=*(pTOCtable+2);
									TXBUFF[3]=*(pTOCtable+3);
									bytes2send=5;
									break;
							case LBPD8:
									TXBUFF[0]=*pTOCtable;
									TXBUFF[1]=*(pTOCtable+1);
									TXBUFF[2]=*(pTOCtable+2);
									TXBUFF[3]=*(pTOCtable+3);
									TXBUFF[4]=*(pTOCtable+4);
									TXBUFF[5]=*(pTOCtable+5);
									TXBUFF[6]=*(pTOCtable+6);
									TXBUFF[7]=*(pTOCtable+7);
									
									bytes2send=9;
									break;
							
							}
					}
					else														//No address included, Last address used xxxx x0xx
					{
						TXBUFF[0]=*pTOCtable;
							bytes2send=2;
					}
					if(command &&  LBPAUTOINC == LBPAUTOINC) {  //AutoInc: 0 leaves address unchanged, 1 specifies that address is post incremented by data size in bytes.
            pTOCtable += (1 << (command & LBPDATASIZE));  //DataSize: Specifies data size, 00b = 1 bytes, 01b = 2 bytes, 10 b= 4 bytes, 11b = 8 bytes.
						}
				}
			}
				break;
		case LBPLOCAL:{															//LBP local function 0-31 11xx xxxx
				if ((command & LBPRWMASK) ==  LBPWRITE)								//LBP local write func		xx1x xxxx 0xE0 a dal
				{
					//
					switch (command){
						case 0xEB:
						case 0xE1:
							LBPstatus = RXBUFF[0];
							TXBUFF[0]=0x00; 						//no crc
							bytes2send=1;
							break;
						case 0xE6:
							sw_mode_index=RXBUFF[0]; 				// setup sw mode
							TXBUFF[0]=0x00; 						//no crc
							bytes2send=1;
							break;											
						case 0xE7:										//clear faults
							TXBUFF[0]=0x00; 						//no crc
							bytes2send=1;
						case 0xEC:										//nejaky potvrzeni
							TXBUFF[0]=0x00; 						//no crc
							bytes2send=1;
					}
				}
				else 															//LBP 	local read func x0x xxxx		0xc0 - 0xdf
				{
					switch (command){
						
						case 0xDF:										//hallo
							TXBUFF[0]=LBPCOOKIECODE ; 	//0x5A
							bytes2send=2;
							break;
						case 0xC1:											// get LBP status
							TXBUFF[0]=LBPstatus;
							bytes2send=2;
							break;
						case 0xC7:											// read state  nonzero = bussy
							TXBUFF[0]=LBPstatus;
							bytes2send=2;
							break;
						case 0xD0:
							TXBUFF[0]=CardName[0];
							bytes2send=2;
							break;
						case 0xD1:
							TXBUFF[0]=CardName[1];
							bytes2send=2;
							break;
						case 0xD2:
							TXBUFF[0]=CardName[2];
							bytes2send=2;
							break;
						case 0xD3:
							TXBUFF[0]=CardName[3];
							bytes2send=2;
							break;
						default :	bytes2read = 0xEE;
							break;
					}
				}
				break ;
			}
		default:		;					//nemelo by nastat  00
				
				

				
			break;										
		}	
		// calc crc
		TXcrc=0;
		for (int i=0; i < bytes2send -1 ; i++) {
			TXcrc=CalcCRC (TXBUFF[i] , TXcrc);
		}
		TXBUFF[bytes2send-1] = TXcrc;
		//  send data 
		HAL_UART_Transmit(&huart1,TXBUFF,bytes2send,5);
	
		
}
//---------------------------------------------------


int CalcCRC(uint8_t	data_byte, uint8_t crc)			//Calculate CRC check
{
	return  CRC_table[crc ^ data_byte];
}





/******END OF FILE****/
