 #ifndef SSERIAL_H__
#define SSERIAL_H__

#include "stm32f4xx.h"
//---------------------------------------------------------
//sserial
#define LBPCOMMAND				0x40	  // Command function 
#define LBPFUNCTIONMASK		0xC0		
#define LBPRWMASK					0x20
#define	LBPADDMASK				0x04


//RPC
#define	LBPRPC						0x80		//Rpc commands 0..63	1000 0000

//LBP
#define LBPLOCAL					0xC0		//local LBP 0-31
#define LBPCOMMAND				0x40		//Command function	0100 0000
#define LBPWRITE					0x20		//Write command			0010 0000
#define LBPA2							0x04		//Two byte address included    0 to specify current address, 1 to specify 2 byte address.
#define LBPAUTOINC				0x08  	//Auto increment 
#define LBPDATASIZE				0x03		//Data Size  00b = 1 bytes, 01b = 2 bytes, 10 b= 4 bytes, 11b = 8 bytes.
#define LBPCOOKIECODE			0x5A 		//return for read cookie

#define LBPD1							0x00						//byte	One byte data
#define LBPD2							0x01						//byte	Two byte data
#define LBPD4							0x02						//byte	Four byte data
#define LBPD8							0x03						//byte	Eight byte data




void sserial_init (void);
int CalcCRC(uint8_t data_byte, uint8_t crc);										//***zmenit na uint8
void send_back (void);
void usart_handler (void);
  

//---------------------------------------------------------
#endif /*SSERIAL_H_ */ 

